package com.ruoyi.system.mapper;

import java.util.List;
import com.ruoyi.system.domain.BomanCamera;

/**
 * 摄像机设备Mapper接口
 * 
 * @author ruoyi
 * @date 2024-01-02
 */
public interface BomanCameraMapper 
{
    /**
     * 查询摄像机设备
     * 
     * @param cameraId 摄像机设备主键
     * @return 摄像机设备
     */
    public BomanCamera selectBomanCameraByCameraId(Long cameraId);

    /**
     * 查询摄像机设备列表
     * 
     * @param bomanCamera 摄像机设备
     * @return 摄像机设备集合
     */
    public List<BomanCamera> selectBomanCameraList(BomanCamera bomanCamera);

    /**
     * 新增摄像机设备
     * 
     * @param bomanCamera 摄像机设备
     * @return 结果
     */
    public int insertBomanCamera(BomanCamera bomanCamera);

    /**
     * 修改摄像机设备
     * 
     * @param bomanCamera 摄像机设备
     * @return 结果
     */
    public int updateBomanCamera(BomanCamera bomanCamera);

    /**
     * 删除摄像机设备
     * 
     * @param cameraId 摄像机设备主键
     * @return 结果
     */
    public int deleteBomanCameraByCameraId(Long cameraId);

    /**
     * 批量删除摄像机设备
     * 
     * @param cameraIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteBomanCameraByCameraIds(Long[] cameraIds);
}
