package com.ruoyi.system.mapper;

import java.util.List;
import com.ruoyi.system.domain.BomanReservatConfigTime;

/**
 * 预约时段配置Mapper接口
 * 
 * @author boman
 * @date 2023-11-02
 */
public interface BomanReservatConfigTimeMapper 
{
    /**
     * 查询预约时段配置
     * 
     * @param reservatConfigTimeId 预约时段配置主键
     * @return 预约时段配置
     */
    public BomanReservatConfigTime selectBomanReservatConfigTimeByReservatConfigTimeId(Long reservatConfigTimeId);

    /**
     * 查询预约时段配置列表
     * 
     * @param bomanReservatConfigTime 预约时段配置
     * @return 预约时段配置集合
     */
    public List<BomanReservatConfigTime> selectBomanReservatConfigTimeList(BomanReservatConfigTime bomanReservatConfigTime);

    /**
     * 新增预约时段配置
     * 
     * @param bomanReservatConfigTime 预约时段配置
     * @return 结果
     */
    public int insertBomanReservatConfigTime(BomanReservatConfigTime bomanReservatConfigTime);

    /**
     * 修改预约时段配置
     * 
     * @param bomanReservatConfigTime 预约时段配置
     * @return 结果
     */
    public int updateBomanReservatConfigTime(BomanReservatConfigTime bomanReservatConfigTime);

    /**
     * 删除预约时段配置
     * 
     * @param reservatConfigTimeId 预约时段配置主键
     * @return 结果
     */
    public int deleteBomanReservatConfigTimeByReservatConfigTimeId(Long reservatConfigTimeId);

    /**
     * 批量删除预约时段配置
     * 
     * @param reservatConfigTimeIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteBomanReservatConfigTimeByReservatConfigTimeIds(Long[] reservatConfigTimeIds);
}
