package com.ruoyi.system.service;

import java.util.List;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.domain.BomanNews;

/**
 * boman_newsService接口
 * 
 * @author boman
 * @date 2023-11-02
 */
public interface IBomanNewsService 
{
    /**
     * 查询boman_news
     * 
     * @param newsId boman_news主键
     * @return boman_news
     */
    public BomanNews selectBomanNewsByNewsId(Long newsId);

    /**
     * 查询boman_news列表
     * 
     * @param bomanNews boman_news
     * @return boman_news集合
     */
    public List<BomanNews> selectBomanNewsList(BomanNews bomanNews);

    /**
     * 新增boman_news
     * 
     * @param bomanNews boman_news
     * @return 结果
     */
    public int insertBomanNews(BomanNews bomanNews);

    /**
     * 修改boman_news
     * 
     * @param bomanNews boman_news
     * @return 结果
     */
    public int updateBomanNews(BomanNews bomanNews);

    /**
     * 批量删除boman_news
     * 
     * @param newsIds 需要删除的boman_news主键集合
     * @return 结果
     */
    public int deleteBomanNewsByNewsIds(Long[] newsIds);

    /**
     * 删除boman_news信息
     * 
     * @param newsId boman_news主键
     * @return 结果
     */
    public int deleteBomanNewsByNewsId(Long newsId);

    /**
     * 发布首页统计
     */
    AjaxResult indexStatisticsInFor ();
}
