package com.ruoyi.system.service;

import java.util.List;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.domain.BomanTouristsNumber;

/**
 * 记录浏览人数Service接口
 * 
 * @author ruoyi
 * @date 2024-04-03
 */
public interface IBomanTouristsNumberService 
{
    /**
     * 查询记录浏览人数
     * 
     * @param touristsId 记录浏览人数主键
     * @return 记录浏览人数
     */
    public BomanTouristsNumber selectBomanTouristsNumberByTouristsId(Long touristsId);

    /**
     * 查询记录浏览人数列表
     * 
     * @param bomanTouristsNumber 记录浏览人数
     * @return 记录浏览人数集合
     */
    public List<BomanTouristsNumber> selectBomanTouristsNumberList(BomanTouristsNumber bomanTouristsNumber);

    /**
     * 新增记录浏览人数
     * 
     * @param bomanTouristsNumber 记录浏览人数
     * @return 结果
     */
    public int insertBomanTouristsNumber(BomanTouristsNumber bomanTouristsNumber);

    /**
     * 修改记录浏览人数
     * 
     * @param bomanTouristsNumber 记录浏览人数
     * @return 结果
     */
    public int updateBomanTouristsNumber(BomanTouristsNumber bomanTouristsNumber);

    /**
     * 批量删除记录浏览人数
     * 
     * @param touristsIds 需要删除的记录浏览人数主键集合
     * @return 结果
     */
    public int deleteBomanTouristsNumberByTouristsIds(Long[] touristsIds);

    /**
     * 删除记录浏览人数信息
     * 
     * @param touristsId 记录浏览人数主键
     * @return 结果
     */
    public int deleteBomanTouristsNumberByTouristsId(Long touristsId);

    AjaxResult num(BomanTouristsNumber bomanTouristsNumber);
}
