package com.ruoyi.system.service;


import com.ruoyi.common.core.redis.RedisCache;
import com.ruoyi.common.core.text.Convert;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.system.domain.BomanTouristsNumber;
import com.ruoyi.system.mapper.BomanTouristsNumberMapper;
import com.ruoyi.system.mapper.SysUserMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;


@Component
public class Task {


    @Autowired
    private static RedisCache redisCache;

    @Autowired
    private BomanTouristsNumberMapper bomanTouristsNumberMapper;

    @Autowired
    public void setRedisCache(RedisCache redisCache) {
        Task.redisCache = redisCache;
    }



    @Async
    //每天的零点1分
    @Scheduled(cron = "0 1 0 * * ? ")
    //@Scheduled(cron = "0 0/2 * * * ?")
    public void generateDb() throws Exception {
        //当前
        String configKey = "lyssllsj";
        //前一天
        String configKey_1 = "lyssllsj_1";
        String configValue = Convert.toStr(redisCache.getCacheObject(configKey));
        if(StringUtils.isEmpty(configValue)){
            redisCache.setCacheObject(configKey_1, String.valueOf("0"));
        }
        redisCache.setCacheObject(configKey_1, configValue);
        redisCache.setCacheObject(configKey, String.valueOf("0"));

        BomanTouristsNumber bomanTouristsNumber = new BomanTouristsNumber();
        bomanTouristsNumber.setNumber(Long.valueOf(configValue));
        //获取当前时间的前一天
        bomanTouristsNumber.setDay(DateUtils.getDateByDays(-1));
        bomanTouristsNumber.setCreateTime(DateUtils.getNowDate());
        bomanTouristsNumberMapper.insertBomanTouristsNumber(bomanTouristsNumber);

        System.out.println("定时任务结束");

    }


    public void generateDbsd(String zt,String jt) throws Exception {



        String configKey = "lyssllsj";
        String configKey_1 = "lyssllsj_1";

        if(StringUtils.isNotEmpty(zt)){
            redisCache.setCacheObject(configKey_1, zt);
            redisCache.setCacheObject(configKey, jt);
            return;
        }
    }


}
